package cn.cslg.report.mapper;

import cn.cslg.report.common.model.vo.FollowUpVO;
import cn.cslg.report.entity.AssoFollowUpFile;
import cn.cslg.report.entity.FollowUp;
import io.swagger.v3.oas.models.security.SecurityScheme;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 后续事项的Mapper层接口
 *
 * @Author xiexiang
 * @Date 2023/4/1
 */
@Repository
public interface FollowUpMapper {
    /**
     * 插入数据
     *
     * @param followUp 后续事项数据对象
     * @return 返回受影响的行数
     */
    int add(FollowUp followUp);

    /**
     * 根据id修改数据
     *
     * @param followUp 后续事项数据对象
     * @return 返回受影响的行数
     */
    int update(FollowUp followUp);



    /**
     * 根据报告id查询后续事项
     *
     * @param reportId 报告id
     * @return 返回查询到的数据
     */
    List<FollowUpVO> query(Integer reportId);

    /**
     * 统计该报告id查询记录的数量
     *
     * @param reportId 报告id
     * @return 返回统计到的总数量total
     */
    int countByReportId(Integer reportId);

    /**
     * 根据ids删除数据
     *
     * @param ids 后续事项ids
     * @return 返回受影响的行数
     */
    int delete(List<Integer> ids);

    /**
     * 根据后续事项id和文件id删除关联数据
     *
     * @param followUpId 后续事项id
     * @param fileIds 文件ids
     * @return 返回受影响的行数
     */
    int deleteAssoId(Integer followUpId, List<Integer> fileIds);

    /**
     * 根据传入后续事项id查询关联表中有的全部fileId
     *
     * @param followUpId
     * @return
     */
    List<Integer> queryFileIdByFollowUpId(Integer followUpId);

    /**
     * 插入后续事项id和附件id关联表
     *
     * @param assoFollowUpFile
     */
    int addAssoIds(AssoFollowUpFile assoFollowUpFile);

}
